diff --git a/rootfs/api/models/resource.py b/rootfs/api/models/resource.py
index cff5439bc..964f13f5d 100644
--- a/rootfs/api/models/resource.py
+++ b/rootfs/api/models/resource.py
@@ -58,7 +58,6 @@ def attach(self, *args, **kwargs):
                 self._scheduler.servicecatalog.create_instance(
                     self.app.id, self.name, **kwargs
                 )
-                # create/patch/put  retrieve_task
                 data = {
                     "task_id": uuid.uuid4().hex,
                     "resource_id": str(self.uuid),
@@ -112,7 +111,6 @@ def bind(self, *args, **kwargs):
             try:
                 self._scheduler.servicecatalog.create_binding(
                     self.app.id, self.name, **kwargs)
-                # create/patch/put  retrieve_task
                 data = {
                     "task_id": uuid.uuid4().hex,
                     "resource_id": str(self.uuid),
@@ -154,10 +152,6 @@ def attach_update(self, *args, **kwargs):
             self._scheduler.servicecatalog.put_instance(
                 self.app.id, self.name, version, **kwargs
             )
-            # self._scheduler.servicecatalog.patch_instance(
-            #     self.app.id, self.name, version, **kwargs
-            # )
-            # create/patch/put  retrieve_task
             data = {
                 "task_id": uuid.uuid4().hex,
                 "resource_id": str(self.uuid),
diff --git a/rootfs/api/tests/test_resource.py b/rootfs/api/tests/test_resource.py
index f41ed7173..b39d036b4 100644
--- a/rootfs/api/tests/test_resource.py
+++ b/rootfs/api/tests/test_resource.py
@@ -102,23 +102,6 @@ def test_resource_delete(self, mock_requests):
         response = self.client.delete(url)
         self.assertEqual(response.status_code, 204)
 
-
-    # def test_resource_update(self, mock_requests):
-    #     """
-    #     Test that update resource from a app, Associated with apply_async
-    #     """
-    #     # create
-    #     app_id = self.create_app()
-    #     data = {'name': 'mysql', 'plan': 'mysql:5.6'}
-    #     self.client.post('/v2/apps/{}/resources'.format(app_id), data=data)
-    #
-    #     # Update
-    #     url = '/v2/apps/{app_id}/resources/{name}'.format(app_id=app_id,
-    #                                                       name='mysql')
-    #     data = {'plan': 'mysql:5.7'}
-    #     response = self.client.put(url, data=data)
-    #     self.assertEqual(response.status_code, 200)
-
     def test_resource_bind(self, mock_requests):
         # create
         app_id = self.create_app()
diff --git a/rootfs/scheduler/resources/servicecatalog.py b/rootfs/scheduler/resources/servicecatalog.py
index 14d5ef033..8ee78c9db 100644
--- a/rootfs/scheduler/resources/servicecatalog.py
+++ b/rootfs/scheduler/resources/servicecatalog.py
@@ -35,19 +35,6 @@ def service_instance_manifest(namespace, name, version=None, **kwargs):
             data["spec"]["externalID"] = kwargs.get('external_id')
         return data
 
-    # @staticmethod
-    # def service_instance_patch_manifest(namespace, name, version=None, **kwargs):
-    #     data = {
-    #         "spec": {
-    #             "clusterServicePlanExternalName": kwargs.get('instance_plan'),
-    #             "parameters": kwargs.get('parameters'),
-    #         }
-    #     }
-    #     if version:
-    #         data["metadata"] = {}
-    #         data["metadata"]["resourceVersion"] = version
-    #     return data
-
     def get_instance(self, namespace, name=None):
         """
         Fetch a single serviceinstance or a list of serviceinstances
@@ -92,16 +79,6 @@ def put_instance(self, namespace, name, version, **kwargs):
                 "update serviceinstances {}".format(namespace))
         return response
 
-    # def patch_instance(self, namespace, name, version, **kwargs):
-    #     data = self.service_instance_patch_manifest(
-    #         namespace, name, version, **kwargs)
-    #     url = self.api("/namespaces/{}/serviceinstances/{}", namespace, name)
-    #     logger.info("patch_instance data:{}".format(data))
-    #     response = self.http_patch(url, json=data)
-    #     if self.unhealthy(response.status_code):
-    #         raise KubeHTTPException(response, "patch serviceinstances {}".format(namespace))
-    #     return response
-
     def delete_instance(self, namespace, name):
         """
         Delete serviceinstances
diff --git a/rootfs/scheduler/tests/test_servicecatalog.py b/rootfs/scheduler/tests/test_servicecatalog.py
index f8e9fcdcd..5f779e14c 100644
--- a/rootfs/scheduler/tests/test_servicecatalog.py
+++ b/rootfs/scheduler/tests/test_servicecatalog.py
@@ -101,13 +101,6 @@ def test_create_binding(self):
         self.scheduler.ns.create("test-serviceinstance")
         self.create_binding(namespace="test-serviceinstance")
 
-    # def test_create_binding_failure(self):
-    #     with self.assertRaises(
-    #         KubeHTTPException,
-    #         msg='failed to create servicebindings doesnotexist in Namespace {}: 404 Not Found'.format(self.namespace) # noqa
-    #     ):
-    #         self.create_binding(self.namespace, 'doesnotexist')
-
     def test_binding_delete(self):
         # test success
         name = self.create_binding(namespace="test-serviceinstance")